"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _icons() {
  const data = require("@ant-design/icons");
  _icons = function _icons() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
var _ = require(".");
var _Branch = require("../Branch");
var _FlowContext = require("../FlowContext");
var _locale = require("../locale");
var _style = _interopRequireDefault(require("../style"));
var _variable = require("../variable");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function findOption(options, paths) {
  let opts = options;
  let option = null;
  for (let i = 0; i < paths.length; i++) {
    const path = paths[i];
    const current = opts.find(item => item.value === path);
    if (!current) {
      break;
    }
    option = current;
    if (current.children) {
      opts = current.children;
    }
  }
  return option;
}
var _default = {
  title: `{{t("Loop", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'loop',
  group: 'control',
  description: `{{t("By using a loop node, you can perform the same operation on multiple sets of data. The source of these sets can be either multiple records from a query node or multiple associated records of a single record. Loop node can also be used for iterating a certain number of times or for looping through each character in a string. However, excessive looping may cause performance issues, so use with caution.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    target: {
      type: 'string',
      title: `{{t("Loop target", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t("A single number will be treated as a loop count, a single string will be treated as an array of characters, and other non-array values will be converted to arrays. The loop node ends when the loop count is reached, or when the array loop is completed. You can also add condition nodes to the loop to terminate it.", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.Input',
      'x-component-props': {
        scope: '{{useWorkflowVariableOptions()}}',
        changeOnSelect: true,
        useTypedConstant: ['string', 'number', 'null'],
        className: (0, _client().css)`
          width: 100%;

          .variable {
            flex: 1;
          }

          .ant-input.null-value {
            width: 100%;
          }
        `
      },
      required: true
    }
  },
  view: {},
  component: function Component({
    data
  }) {
    var _entry$branchIndex;
    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
      nodes = _useFlowContext.nodes;
    const _useStyles = (0, _style.default)(),
      styles = _useStyles.styles;
    const entry = nodes.find(node => node.upstreamId === data.id && node.branchIndex != null);
    return _react().default.createElement(_.NodeDefaultView, {
      data: data
    }, _react().default.createElement("div", {
      className: styles.nodeSubtreeClass
    }, _react().default.createElement("div", {
      className: (0, _client().cx)(styles.branchBlockClass, (0, _client().css)`
                padding-left: 20em;
              `)
    }, _react().default.createElement(_Branch.Branch, {
      from: data,
      entry: entry,
      branchIndex: (_entry$branchIndex = entry === null || entry === void 0 ? void 0 : entry.branchIndex) !== null && _entry$branchIndex !== void 0 ? _entry$branchIndex : 0
    }), _react().default.createElement("div", {
      className: styles.branchClass
    }, _react().default.createElement("div", {
      className: "workflow-branch-lines"
    }), _react().default.createElement("div", {
      className: (0, _client().cx)(styles.addButtonClass, styles.loopLineClass)
    }, _react().default.createElement(_icons().ArrowUpOutlined, null)))), _react().default.createElement("div", {
      className: (0, _client().css)`
              position: relative;
              height: 2em;
            `
    })));
  },
  scope: {
    useWorkflowVariableOptions: _variable.useWorkflowVariableOptions
  },
  components: {},
  useScopeVariables(node, options) {
    const compile = (0, _client().useCompile)();
    const target = node.config.target;
    if (!target) {
      return null;
    }
    const _options$fieldNames = options.fieldNames,
      fieldNames = _options$fieldNames === void 0 ? _variable.defaultFieldNames : _options$fieldNames;
    // const { workflow } = useFlowContext();
    // const current = useNodeContext();
    // const upstreams = useAvailableUpstreams(current);
    // find target data model by path described in `config.target`
    // 1. get options from $context/$jobsMapByNodeId
    // 2. route to sub-options and use as loop target options
    let targetOption = {
      key: 'item',
      [fieldNames.value]: 'item',
      [fieldNames.label]: (0, _locale.lang)('Loop target')
    };
    if (typeof target === 'string' && target.startsWith('{{') && target.endsWith('}}')) {
      const paths = target.slice(2, -2).split('.').map(path => path.trim());
      const targetOptions = [_variable.nodesOptions, _variable.triggerOptions].map(item => {
        const opts = item.useOptions(options).filter(Boolean);
        return {
          [fieldNames.label]: compile(item.title),
          [fieldNames.value]: item.value,
          key: item.value,
          [fieldNames.children]: opts,
          disabled: opts && !opts.length
        };
      });
      const found = findOption(targetOptions, paths);
      targetOption = Object.assign(_objectSpread({}, targetOption), found, targetOption);
    }
    return [targetOption, {
      key: 'index',
      [fieldNames.value]: 'index',
      [fieldNames.label]: (0, _locale.lang)('Loop index')
    }, {
      key: 'length',
      [fieldNames.value]: 'length',
      [fieldNames.label]: (0, _locale.lang)('Loop length')
    }];
  }
};
exports.default = _default;