"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _antdV() {
  const data = require("@formily/antd-v5");
  _antdV = function _antdV() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _locale = require("../locale");
var _variable = require("../variable");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _default = {
  title: `{{t("HTTP request", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'request',
  group: 'extended',
  description: `{{t("Send HTTP request to a URL. You can use the variables in the upstream nodes as request headers, parameters and request body.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    method: {
      type: 'string',
      required: true,
      title: `{{t("HTTP method", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        showSearch: false,
        allowClear: false
      },
      enum: [{
        label: 'GET',
        value: 'GET'
      }, {
        label: 'POST',
        value: 'POST'
      }, {
        label: 'PUT',
        value: 'PUT'
      }, {
        label: 'PATCH',
        value: 'PATCH'
      }, {
        label: 'DELETE',
        value: 'DELETE'
      }],
      default: 'POST'
    },
    url: {
      type: 'string',
      required: true,
      title: `{{t("URL", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'Input',
      'x-component-props': {
        placeholder: 'https://www.nocobase.com',
        className: 'full-width'
      }
    },
    headers: {
      type: 'array',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      title: `{{t("Headers", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t('"Content-Type" only support "application/json", and no need to specify', { ns: "${_locale.NAMESPACE}" })}}`,
      items: {
        type: 'object',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            properties: {
              name: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Name")}}`
                }
              },
              value: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Variable.Input',
                'x-component-props': {
                  scope: '{{useWorkflowVariableOptions()}}',
                  useTypedConstant: true
                }
              },
              remove: {
                type: 'void',
                'x-decorator': 'FormItem',
                'x-component': 'ArrayItems.Remove'
              }
            }
          }
        }
      },
      properties: {
        add: {
          type: 'void',
          title: `{{t("Add request header", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-component': 'ArrayItems.Addition'
        }
      }
    },
    params: {
      type: 'array',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      title: `{{t("Parameters", { ns: "${_locale.NAMESPACE}" })}}`,
      items: {
        type: 'object',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            properties: {
              name: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Name")}}`
                }
              },
              value: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Variable.Input',
                'x-component-props': {
                  scope: '{{useWorkflowVariableOptions()}}',
                  useTypedConstant: true
                }
              },
              remove: {
                type: 'void',
                'x-decorator': 'FormItem',
                'x-component': 'ArrayItems.Remove'
              }
            }
          }
        }
      },
      properties: {
        add: {
          type: 'void',
          title: `{{t("Add parameter", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-component': 'ArrayItems.Addition'
        }
      }
    },
    data: {
      type: 'string',
      title: `{{t("Body", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'RequestBody',
      'x-component-props': {
        changeOnSelect: true,
        autoSize: {
          minRows: 10
        },
        placeholder: `{{t("Input request data", { ns: "${_locale.NAMESPACE}" })}}`,
        className: 'full-width'
      },
      description: `{{t("Only support standard JSON data", { ns: "${_locale.NAMESPACE}" })}}`
    },
    timeout: {
      type: 'number',
      title: `{{t("Timeout config", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'InputNumber',
      'x-component-props': {
        addonAfter: `{{t("ms", { ns: "${_locale.NAMESPACE}" })}}`,
        min: 1,
        step: 1000,
        defaultValue: 5000
      }
    },
    ignoreFail: {
      type: 'boolean',
      title: `{{t("Ignore fail request and continue workflow", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox'
    }
  },
  view: {},
  scope: {
    useWorkflowVariableOptions: _variable.useWorkflowVariableOptions
  },
  components: {
    ArrayItems: _antdV().ArrayItems,
    RequestBody(props) {
      const scope = (0, _variable.useWorkflowVariableOptions)();
      return _react().default.createElement(_client().Variable.JSON, _objectSpread({
        scope: scope
      }, props));
    }
  }
};
exports.default = _default;